include({choice.m4})

comment({	Portable implementation of the LLL kernel	})

comment({	The choice constructs will select the best	})
comment({	implementation ;-)				})


forget({
* Whenever a common interface can be found, move everything
from choices to macros defined in specialization files.

* ANSI Forth recommends TOS=hi, NOS=lo for double word set
})


defdef({NOS},{point(DSP)})dnl
defdef({TSE},{point(DSP+DSINC)})dnl
defdef({Nip},{Add(DSP,DSINC)})dnl
defdef({PopData},{Mov($1,TOS)}__nl__{Mov(TOS,NOS)}__nl__{Nip})dnl
defdef({Mov},{ifelse({$1},,,{$1},{$2},,{__Mov__($1,$2)})})dnl
defdef({__Seq__},{ifelse({$*},,,{shift($@)},,{$1}{Terminator},
	        {$1}{Terminator}{Separator}{Seq(shift($@))})})dnl
defdef({Seq},{Begin}{__Seq__($@)}{End})dnl
defdef({Shr},{ifelse($2,,{__Shr__($1,1)},{__Shr__($1,$2)})})dnl


dnl  * definir le nom FORTH
dnl  * trouver une etiquette assembleur
dnl  * la definir OU utiliser un alias
dnl  * 

defdef({DefWord},
   {__DefWord__($@)})dnl



comment({----- Defining Macros -----})

define({DefCompare0Word},
{DefWord({$1},{$2},{$3})
   Enter
   choice({
      option({ANSIC},{
	   TOS=(TOS $4 0)?FALSE:TRUE ;
      })
      option({i386},{
	  test TOS,TOS
	  set$5 TOSLL
       _compare0adj:
	  movsx TOS,TOSLL
      })
   })
   Next
})dnl


define({DefCompare0Word},
{DefWord({$1},{$2},{$3})
	Enter
   choice({
     option({ANSIC},{
	TOS=(TOS $4 NOS?TRUE:FALSE) ;
      })
     option({i386},{
	 cmp TOS,NOS
	 set$5 TOSLL
       _compare0adj:
	 movsx TOS,TOSLL
     })
   })
   Nip
   Next
})


define({DefBinOpWord},
{DefWord({$1},{$2},{$3})
   Enter
   $4(TOS,NOS)
   Nip
   Next
})

define({DefUnOpWord},
{DefWord({$1},{$2},{$3})
   Enter
   $4(TOS,$5)
   Nip
   Next
})




__codeseg__({



comment({----- Integer Arithmetics -----})


DefBinOpWord(SWAP-,RSUB,,{Sub})
DefUnOpWord(2/,SHR,,{Shr},1)

DefWord(-,SUB)
	Neg(TOS)
DefBinOpWord(+,ADD,,{Add})


DefWord(>>,SHRN)
	Enter
	Mov(COUNT,TOS)
	PopData(TOS)
	Shr(TOS,COUNTLO)
	Next

DefWord(NEGATE)
	Enter
  Neg0:	Neg(TOS)
	Next


DefWord(ABS)
	Enter
choice({
    option({generic},{
	gotos(TOS,Neg0)
    })
    option({i386},{
	;Mov(eax,TOS)
	;CDQ
	;Xor(eax,edx)
	;Sub(eax,edx)
	;Mov(TOS,eax)
    })
    option({ANSIC},{
	if(TOS<0){TOS=-TOS};
    })
})
	Next


DefUnOpWord(1+,INC,,{Inc})



comment({----- Basic Multiplication operators -----})


DefWord(M*,m_star)
	Enter
choice({
    option({i386},{
	Mov(eax,NOS)
	imul TOS
	Mov(NOS,eax)
	Mov(TOS,edx)
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        dcell Prod = TOS * NOS ;
	Mov(NOS,(cell)Prod) ;
	Mov(TOS,(cell)(Prod>>CELLABITS)) ;
    })
})
	Next


DefWord(UM*,u_m_star)
	Enter
choice({
    option({i386},{
	Mov(eax,NOS)
	mul TOS
	Mov(NOS,eax)
	Mov(TOS,edx)
    })
    option({ANSIC},{
	......
    })
    option({GCC},{
        udcell Prod = TOS * NOS ;
	Mov(NOS,(cell)Prod) ;
	Mov(TOS,(cell)(Prod>>CELLABITS)) ;
    })
})
	Next


DefWord(SM/REM,s_m_slash_rem)
	Clr(edx)
	Mov(eax,NOS)
	idiv(TOS)
	Mov(NOS,eax)
	Mov(TOS,edx)
	Next


DefWord(UM/MOD,u_m_slash_mod)
	Enter
	Mov(edx,TOS)
	Pop(eax)
	Pop(TOS)
	
	Pop(edx)
	Pop(eax)
	Clr(edx)
	Mov(eax,NOS)
	idiv(TOS)
	Mov(NOS,eax)
	Mov(TOS,edx)
	Next






comment({----- Pointer Arithmetics -----})

DefUnOpWord(CELL+,CELL_PLUS,,{Add},CELL)
DefUnOpWord(CELLS,,,{Shl},CELLABITS)



comment({----- Integer as boolean arrays Arithmetics -----})

DefUnOpWord(NOT,NOT,,{Not})
DefWord(INVERT,INVERT,NOT)

DefBinOpWord(AND,,,{And})
DefBinOpWord(XOR,,,{Xor})
DefBinOpWord(OR,,,{Or})

DefWord(FLAG,,0NEQ)



comment({----- USING POINTERS -----})

DefWord(!,STO)
	Enter
	Mov(R0,NOS)
	Mov(point(TOS),R0)
	Mov(TOS,point(DSP,2*CELL))
	Add(DSP,2*CELL)
	Next

DefWord(@,LOD)
	Enter
	Mov(TOS,point(TOS))
	Next

DefWord(C!,CSTO)
	Enter
	Mov(R0,NOS)
	Mov(point(TOS),R0LL)
	mov TOS,point(esi+4)
	add esi,8
	Next

DefWord(C@,CLOD)
	Enter
choice({
    option({i386},{
	movzx TOS,byte point(TOS)
    })
    option({generic},{
	Mov(TOSLL,point(TOS))
	And(TOS,~CHARMASK)
    })
})
	Next

DefWord(W!,WSTO)
	Enter
	Mov(R0,NOS)
	Mov(point(TOS),R0L)
	mov TOS,point(esi+4)
	add esi,8
	Next

DefWord(W@,WLOD)
	Enter
choice({
    option({i386},{
	movzx TOS,word point(TOS)
    })
    option({generic},{
	Mov(TOSL,point(TOS))
	And(TOS,~WORDMASK)
    })
})
	Next


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;; NUMBER COMPARISON ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Equality


DefWord(0=,0EQ)
	Enter
choice({
    option({i386},{
	test TOS,TOS
	setz bl
      _compare0adj:
	movsx TOS,bl
    })
    option({ANSIC},{
	TOS=TOS?FALSE:TRUE ;
    })
})
	Next

DefWord(=,EQ)
	Enter
choice({
    option({i386},{
	cmp TOS,NOS
	setz TOSLL
      _compare0adj:
	movsx TOS,TOSLL
    })
    option({ANSIC},{
	TOS=(TOS==NOS?TRUE:FALSE) ;
	Nip
    })
})
	Next


.......
DefWord(0<>,0NEQ,,)


DefWord(<>,NEQ)
	Enter
	cmp TOS,point(esi)
	setne bl
	movsx TOS,bl
	add esi,4
	Next

;;; Signed number comparison to zero
DefWord(0<,0LT)
			or TOS,TOS
			setl bl
			movsx TOS,bl
			Next
DefWord(0<=,0LE)
			or TOS,TOS
			setle bl
			movsx TOS,bl
			Next
DefWord(0>,0GT)
			or TOS,TOS
			setg bl
			movsx TOS,bl
			Next
DefWord(0>=,0GE)
			or TOS,TOS
			setge bl
			movsx TOS,bl
			Next
;;; Signed number comparison
DefWord(<,LT)
			cmp point(esi),TOS
			setl bl
			movsx TOS,bl
			add esi,4
			Next
DefWord(LE)
			cmp point(esi),TOS
			setg bl
			movsx TOS,bl
			add esi,4
			Next
DefWord(GT)
			cmp point(esi),TOS
			setg bl
			movsx TOS,bl
			add esi,4
			Next
DefWord(GE)
			cmp TOS,point(esi)
			setge bl
			movsx TOS,bl
			add esi,4
			Next
;;; Unsigned number comparison
DefWord(ULT)
			cmp TOS,point(esi)
			setb bl
			movsx TOS,bl
			add esi,4
			Next
DefWord(ULE)
			cmp TOS,point(esi)
			setbe bl
			movsx TOS,bl
			add esi,4
			Next
DefWord(UGT)
			cmp TOS,point(esi)
			seta bl
			movsx TOS,bl
			add esi,4
			Next
DefWord(UGE)
			cmp TOS,point(esi)
			setae bl
			movsx TOS,bl
			add esi,4
			Next




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CONSTANTS ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Macro def_CSTK_		constant
DefWord(&constant)
			sub esi,4
			mov point(esi),TOS
			mov TOS,constant
			Next
EndM

	MINUS1 = -1
	MINUS2 = -2
	MINUS4 = -4
	MAXINT = (1 SHL 30) -1
	MININT = - (1 SHL 30)

	num=0
	rept 32
	  def_CSTK_ %num
	  num=num+1
	endm
	def_CSTK_ MINUS1
	def_CSTK_ MINUS2
	def_CSTK_ MINUS4
	def_CSTK_ MAXINT
	def_CSTK_ MININT

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;; STACK MANIPULATION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DefWord(SWAP)
			xchg TOS,point(esi)
;			Next		; not necessary as another Next follows
DefWord(NOP)
			Next
DefWord(OVER)
			sub esi,4
			mov point(esi),TOS
			mov TOS,point(esi+4)
			Next
DefWord(DUP)
			sub esi,4
			mov point(esi),TOS
			Next
DefWord(PICK)
			mov TOS,point(esi+TOS*4)
			Next
DefWord(ROT)
			mov eax,point(esi)
			mov point(esi),TOS
			mov TOS,point(esi+4)
			mov point(esi+4),eax
			Next
DefWord(ROTROT)
			mov eax,point(esi+4)
			mov point(esi+4),TOS
			mov TOS,point(esi)
			mov point(esi),eax
			Next

DefWord(ROLL)
			mov ecx,TOS
			jecxz CSTK_DROP
			mov TOS,edi
			mov edi,esi
			mov eax,point(esi)
		cstk_roll_0)
			xchg eax,point(edi)
			add edi,4
			loop cstk_roll_0
			mov edi,TOS
;			mov TOS,eax		; DROP follows
;			add esi,4
;			Next
DefWord(DROP)
			mov TOS,point(esi)
;			add esi,4
;			Next
DefWord(NIP)
			add esi,4
			Next

DefWord(ROLLD)
			mov ecx,TOS
			jecxz CSTK_NOP
			mov TOS,point(esi+ecx+4)
			mov eax,point(esi)
		cstk_rolld_0)
			xchg eax,point(esi+ecx*4)
			loop cstk_rolld_0
			add esi,4
			Next
DefWord(2DROP)
			mov TOS,point(esi+4)
			add esi,8
			Next
DefWord(2NIP)
			mov TOS,point(esi+4)
			mov eax,point(esi)
			add esi,8
			mov point(esi),eax
			Next
DefWord(2SWAP)
			xchg TOS,point(esi+4)
			mov eax,point(esi)
			xchg eax,point(esi+8)
			mov point(esi),eax
			Next
DefWord(2DUP)
			mov eax,point(esi)
			sub esi,8
			mov point(esi),eax
			mov point(esi+4),TOS
			Next
DefWord(2OVER)
			mov eax,point(esi+8)
			sub esi,8
			mov point(esi),eax
			mov point(esi+4),TOS
			mov TOS,point(esi+12)
			Next


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;; PROGRAM CONTROL, RET-based Threading ;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Words with different behaviour when using a control loop
;; for indirect threading or debugging
;; direct threading (no debugging control loop))
;;  point(esp) is just the direct code pointer
;;  point(ebp) is the environment pointer
;; environment is in

DefWord(R_ENV)
			lea TOS,point(ebp+4*TOS)
			Next

DefWord(R_IMM)
			sub esi,4
			mov point(esi),TOS
			pop TOS
			Next
DefWord(R_GOTO)
			mov esp,TOS
			mov TOS,point(esi)
			add esi,4
			Next
DefWord(R_BRZ)
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			add esp,eax
			Next
DefWord(R_BRNZ)
			pop eax
			test TOS,TOS
			jz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			add esp,eax
			Next
DefWord(R_BRA)
			pop eax
			add esp,eax
			Next
DefWord(R_SKIP)
			pop eax
			Next
DefWord(R_JZ)
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			mov esp,eax
			Next
DefWord(R_JNZ)
			pop eax
			test TOS,TOS
			jz short CSTK_R_DROP
			mov TOS,point(esi)
			add esi,4
			mov esp,eax
			Next
DefWord(R_JMP)
			pop esp
			Next
DefWord(R_BSR)
			pop eax
			add edi,4
			mov point(edi),esp
			add esp,eax
			Next
DefWord(R_JSR)
			pop eax
			add edi,4
			mov point(edi),esp
			mov esp,eax
			Next
DefWord(R_RET)
			mov esp,point(edi)
			sub edi,4
			Next


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;; PROGRAM CONTROL, Bytecode threading ;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Words with different behaviour when using a control loop
;; for indirect threading or debugging
;; Indirect threading)
;;  point(esp) is just the usual indirect threading routine
;;  point(ebp) is the bytecode pointer
;; environment is in point(esp+4)

DefWord(B_ENV)
			mov edx,point(esp+4)
			lea TOS,point(edx+TOS*4)
			Next
DefWord(B_IMM8)
			sub esi,4
			mov point(esi),TOS
			movzx TOS,point(BYTE ebp)
			inc ebp
			Next
DefWord(B_IMM16)
			sub esi,4
			mov point(esi),TOS
			movzx TOS,point(WO ebp)
			inc ebp
			Next
DefWord(B_IMM32)
			sub esi,4
			mov point(esi),TOS
			mov TOS,point(ebp)
			add ebp,4
			Next
DefWord(B_GOTO)
			mov esp,TOS
			mov TOS,point(esi)
			add esi,4
			Next
DefWord(B_BRZ)
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			add esp,eax
			Next
DefWord(B_BRA)
			pop eax
			add esp,eax
			Next
DefWord(B_SKIP)
			pop eax
			Next
DefWord(B_JZ)
			pop eax
			test TOS,TOS
			jnz short CSTK_DROP
			mov TOS,point(esi)
			add esi,4
			mov esp,eax
			Next
DefWord(B_JMP)
			pop esp
			Next
DefWord(B_BSR)
			pop eax
			sub edi,4
			mov point(edi),esp
			add esp,eax
			Next
DefWord(B_JSR)
			pop eax
			sub edi,4
			mov point(edi),esp
			mov esp,eax
			Next
DefWord(B_RET)
			mov esp,point(edi)
			add edi,4
			Next

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;; EXECUTION CONTROL ;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DefWord(THREAD)
;			mov point(ebp+SAVE_SS),ss
;			mov point(ebp+SAVE_ESP),esp
;			mov ss,ds
			pop esp
			Next


	EXEC_MANY)
	;; executes ECX kernel instructions pointed at by EBX
			xchg TOS,esi
			mov edx,edi
			lea eax,point(ecx*4)
			sub esp,eax
			mov eax,point(TOS)
			@REPEAT
			  push eax
			  add TOS,4
			  mov eax,point(TOS)
			  or eax,eax
			@UNTIL z
			Next

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;; MULTITHREADING ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;NOP_CODE = 90h
	;87 DB is xchg TOS,TOS
	RETN_CODE = 0C3h
	DSOVRR_CODE = 3Eh
	ESOVRR_CODE = 26h
	SSOVRR_CODE = 36h
	CSOVRR_CODE = 2Eh
	FSOVRR_CODE = 64h
	GSOVRR_CODE = 65h
	PUSHIMM_CODE = 69h

DefWord(PAUSE)
		AbsJmp CSTK_YIELD
DefWord(YIELD)

		mov point(BY CSTK_PAUSE),RETN_CODE


forget({
Not implemented:
#
#>
#S	number
'	tick

})
